package Freenet;

import java.lang.reflect.*;
import java.net.*;

public class ListenerFactory
{
  static public Listener listen(String str) throws BindException
  {
    return listen(new ListeningAddress(str));
  }

  static public Listener listen(ListeningAddress address) throws BindException
  {
    try
    {
      Class c=Class.forName("Freenet."+address.protocol+"Listener");
      Class[] carr={Class.forName("Freenet."+address.protocol+"ListeningAddress")};
      Constructor con=c.getConstructor(carr);
      Object[] aar={address.address};
      return (Listener)con.newInstance(aar);
    }
    catch(InvocationTargetException e)
    {
	if (e.getTargetException() instanceof BindException)
	    throw (BindException) e.getTargetException();
      e.getTargetException().printStackTrace();
      return null;
    }
    catch(Exception e) { e.printStackTrace(); return null; }
  }
}




