package Freenet.client;
import Freenet.*;
import Freenet.support.Logger;
import Freenet.message.*;

public class ClientMessageHandler implements MessageHandler {
    public Thread ct;
    public Message last;
    private ClientCore cc;

    public ClientMessageHandler(ClientCore cc, Thread ct) { 
	this.ct = ct;
    }

    public void handle(Message m) {
	if (m instanceof HandshakeRequest) {
	    HandshakeReply shake = new HandshakeReply(m.id);
	
	    try {
		if (m.receivedWith == null || !m.receivedWith.isOpen()) {
		    Logger.log("ClientMessageHandler.java","Opening new connection",Logger.DEBUGGING);
		    m.receivedWith = cc.connect(m.source);
		}
		shake.sending(cc,m.receivedWith);
		m.receivedWith.sendMessage(shake);
	    } catch(SendFailedException e) {Logger.log("ClientMessageHandler.java","Could not send handshake reply",Logger.MINOR);
	    } catch(ConnectFailedException e) {Logger.log("ClientMessageHandler.java","Could not send handshake reply",Logger.MINOR);
	    }
	    return;
	} else {
	    last = m;
	    ct.interrupt();
	}
    }
}
