/* 
	MainFrame.java

	Title:			Freenet GUI
	Author:			Paul Kappler
	Description:	
*/
package Freenet.contrib.FGUI;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import Freenet.support.ByteCounter;

public class MainFrame extends java.awt.Frame 
{
    final static int BAR_AREA_SIZE = 50;
    final static int BAR_HEIGHT = 10;
    final static int BAR_WIDTH = 400;
    final static int BAR_LEFT = 20;
    final static int BAR_TOP = 300;
    Image image;
    Graphics graphics;
    Vector bars;
	
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
	// member declarations
	java.awt.Button insertFileButton = new java.awt.Button();
	java.awt.Button requestFileButton = new java.awt.Button();
	java.awt.TextField keyField = new java.awt.TextField();
	java.awt.Label KeyLabel = new java.awt.Label();
	java.awt.TextField serverField = new java.awt.TextField();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.TextField htlField = new java.awt.TextField();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Button serverButton = new java.awt.Button();
// END GENERATED CODE

	public MainFrame()
	{
		bars = new Vector();
	}

	public void initComponents() throws Exception
	{
// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
		// the following code sets the frame's initial state
		insertFileButton.setLocation(new java.awt.Point(120, 70));
		insertFileButton.setLabel("Insert File...");
		insertFileButton.setVisible(true);
		insertFileButton.setSize(new java.awt.Dimension(100, 30));

		requestFileButton.setLocation(new java.awt.Point(290, 70));
		requestFileButton.setLabel("Request File...");
		requestFileButton.setVisible(true);
		requestFileButton.setSize(new java.awt.Dimension(100, 30));

		keyField.setLocation(new java.awt.Point(120, 20));
		keyField.setVisible(true);
		keyField.setSize(new java.awt.Dimension(270, 30));

		KeyLabel.setText("Key:");
		KeyLabel.setLocation(new java.awt.Point(20, 20));
		KeyLabel.setAlignment(Label.RIGHT);
		KeyLabel.setVisible(true);
		KeyLabel.setSize(new java.awt.Dimension(80, 30));

		serverField.setLocation(new java.awt.Point(120, 170));
		serverField.setVisible(true);
		serverField.setSize(new java.awt.Dimension(220, 30));

		label1.setText("Server:");
		label1.setLocation(new java.awt.Point(20, 170));
		label1.setAlignment(Label.RIGHT);
		label1.setVisible(true);
		label1.setSize(new java.awt.Dimension(80, 30));

		label2.setText("(Leave server blank to use a server on port 19114 on the this computer)");
		label2.setLocation(new java.awt.Point(20, 220));
		label2.setVisible(true);
		label2.setSize(new java.awt.Dimension(400, 30));

		htlField.setText("5");
		htlField.setLocation(new java.awt.Point(120, 120));
		htlField.setVisible(true);
		htlField.setSize(new java.awt.Dimension(60, 30));

		label4.setText("Hops To Live:");
		label4.setLocation(new java.awt.Point(20, 120));
		label4.setAlignment(Label.RIGHT);
		label4.setVisible(true);
		label4.setSize(new java.awt.Dimension(80, 30));

		serverButton.setLocation(new java.awt.Point(360, 170));
		serverButton.setLabel("Server List");
		serverButton.setVisible(true);
		serverButton.setSize(new java.awt.Dimension(70, 30));

		setLocation(new java.awt.Point(0, 0));
		setTitle("Freenet Client");
		setLayout(null);
		setSize(new java.awt.Dimension(440, 450));
		add(insertFileButton);
		add(requestFileButton);
		add(keyField);
		add(KeyLabel);
		add(serverField);
		add(label1);
		add(label2);
		add(htlField);
		add(label4);
		add(serverButton);


		insertFileButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				insertFileButtonActionPerformed(e);
			}
		});
		requestFileButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				requestFileButtonActionPerformed(e);
			}
		});
		serverButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				serverButtonActionPerformed(e);
			}
		});
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});
// END GENERATED CODE
		setResizable(false);
		setBackground(SystemColor.control);
		setSize();
			
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((screen.width - getSize().width) / 2, (screen.height - getSize().height) / 3);
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() 
	{
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}

		mShown = true;
	}

	/**
	 * OS dependendent Close Button
	 */
	void thisWindowClosing(java.awt.event.WindowEvent e)
	{
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	/**
	 * Insert File... Button
	 */
	public void insertFileButtonActionPerformed(java.awt.event.ActionEvent e)
	{
		String key = keyField.getText();
		if (key.equals(""))
			return;
		FileDialog dialog = new FileDialog(this, "Choose a file to insert:", FileDialog.LOAD);
		dialog.show();
		if (null == dialog.getFile())
			return;
		String file = dialog.getDirectory() + dialog.getFile();
		ProgressBar bar = new ProgressBar(this,key);
		bars.addElement(bar);
		setSize();
		
		SimpleInsertClient client = new SimpleInsertClient();
		client.setFile(file);
		client.setKey(key);
		client.setCounter(bar);
		client.setHopsToLive(Integer.parseInt(htlField.getText()));
		client.setServer(serverField.getText());
		client.start();
	}
	
	
	/**
	 * Request File.. Button
	 */
	public void requestFileButtonActionPerformed(java.awt.event.ActionEvent e)
	{
		String key = keyField.getText();
		if (key.equals(""))
			return;
			
		
		FileDialog dialog = new FileDialog(this, "Save the file you request:", FileDialog.SAVE);
		dialog.show();
		if (null == dialog.getFile())
			return;
		String file = dialog.getDirectory() + dialog.getFile();
		ProgressBar bar = new ProgressBar(this,key);
		bars.addElement(bar);
		setSize();
		
		SimpleRequestClient client = new SimpleRequestClient();
		client.setFile(file);
		client.setKey(key);
		client.setCounter(bar);
		client.setHopsToLive(Integer.parseInt(htlField.getText()));
		client.setServer(serverField.getText());
		client.start();
	}
	
	/**
	 * Server List Button
	 */ 	
	public void serverButtonActionPerformed(java.awt.event.ActionEvent e)
	{
		try {
			PickFrame frame = new PickFrame(serverField,"http://freenet.sourceforge.net/inform.php");
			frame.initComponents();
			frame.setVisible(true);
			
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
	
	}

    /**
     * Override update/paint to double buffer - to prevent flickering.
     */
    public void update(Graphics g) {
	paint(g);
    }

    /**
     * Paint the window.
     */
    public void paint(Graphics g) {
	// create the offscreen image
	if (image == null) {
	    image = createImage(getSize().width, getSize().height);
	    graphics = image.getGraphics();
	}

	// erase the offscreen image
	graphics.setColor(getBackground());
	graphics.fillRect(0, 0, getSize().width, getSize().height);
	graphics.setColor(getForeground());

	
	ProgressBar doneBar = null;
	Rectangle rect = new Rectangle(BAR_LEFT,BAR_TOP , BAR_WIDTH, BAR_HEIGHT);
	for (Enumeration i = bars.elements() ; i.hasMoreElements() ;) {
		ProgressBar bar =(ProgressBar)(i.nextElement());
		if (bar.done)
		{
			doneBar = bar;
			setSize();
			continue;
		}
		// paint into the offscreen image
		bar.paint(graphics, rect);
		
		rect = new Rectangle(BAR_LEFT, rect.y + BAR_AREA_SIZE, BAR_WIDTH, BAR_HEIGHT);
	}
	if (doneBar != null)
		bars.removeElement((Object)(doneBar));//Progress bar to be removed when done
		

	// draw the offscreen image into the window
	g.drawImage(image, 0, 0, null);
    }
    
    
    void setSize()
    {
    	/*setSize(new Dimension(getSize().width, bars.size()*BAR_AREA_SIZE + 310));*/
    }
}
