package Freenet.contrib.FGUI;


import java.io.*;
import java.util.*;
import Freenet.*;
import Freenet.crypt.*;
import Freenet.support.*;
import Freenet.message.*;
import Freenet.client.*;


public class SimpleInsertClient extends SimpleClient {
	public void run()
	{
		try {
			// process options
			ListeningAddress lstaddr = new ListeningAddress(listeningAddress);
			Address addr = new Address(server);
			Long length = new Long(new File(file).length());
			InputStream in = new FileInputStream(file);
		   
			Core.connectTimeout=10000;
			Core.handshakeTimeout=10000;
			Core.handshakeLife=1000000;
			if (Core.timer == null)
				{Core.timer=new Ticker(500);}
			Logger.threshold=Logger.NORMAL;

		   
			InsertClient ic = new InsertClient(addr, lstaddr, htl, (Math.abs((new Random()).nextLong()) % 30));			
		    ic.insert(key, in, length,counter);
		    counter.start(length.longValue(), file);
		}
		catch (IOException ioe) {
			System.err.println(ioe);
			counter.finished();
		}
	    catch(BadHandshakeException e) {
	      System.err.println("Bad handshake");
	      counter.finished();
		} 
		catch (SendFailedException sfe) {
	    	System.err.print("Couldn't connect to the specified Freenet server - ");
			System.err.println("have you started it?");
			counter.finished();
			
	    }
		catch (ClientException ce) {
	    	if (ce.msg == null) {
				System.err.println ("Network timed out waiting for a reply from the server.");
	    	} 
	    	else if (ce.msg instanceof RequestFailed) {
				System.err.println("The insert could not find a route. Lower the hops-to-live and try again."); 
	    	}
	    	else if (ce.msg instanceof DataReply) {
				System.err.println("Key collision, insert again under a different key.");
				synchronized(((DataReply)ce.msg).in) {
		    		((DataReply)ce.msg).in.notify();
				}
	    	}
	    	else {
				System.err.println("Received unexpected reply " + ce.msg);
	    	}
	    	counter.finished();
	    	
		}
	}
}