package Freenet.contrib.FGUI;

import java.io.*;
import java.util.*;
import Freenet.*;
import Freenet.crypt.*;
import Freenet.support.*;
import Freenet.message.*;
import Freenet.client.*;


public class SimpleRequestClient extends SimpleClient implements Callback {

OutputStream out;

public void run()
{
	// process options
	try {
		ListeningAddress lstaddr = new ListeningAddress(listeningAddress);
		Address addr = new Address(server);
		out = new FileOutputStream(file);

		Core.connectTimeout = 30000;
	    Core.handshakeTimeout = 30000;
		Core.handshakeLife=1000000;
   		Core.connectTimeout=10000;
    	if (Core.timer == null)
			{Core.timer=new Ticker(500);}

		Logger.threshold=Logger.NORMAL;

		RequestClient rc = new RequestClient(addr, lstaddr, htl, (Math.abs((new Random()).nextLong()) % 30));
		DataReply reply = rc.request(key);
		InputStream stream= reply.in;
        counter.start(reply.length.longValue(), file);

		Conduit cond=new Conduit(stream, out, counter);
		cond.asyncFeed(this,this,reply.length.longValue());
    }
    catch(IOException e) {
		System.err.println(e);
		counter.finished();
    }
 	catch(BadHandshakeException e) {
        System.err.println("Bad handshake from node");
        counter.finished();
	}
	catch (SendFailedException sfe) {
	    System.err.print("Couldn't connect to the specified Freenet server - ");

		System.err.println("have you started it?");
		System.err.println("please try a different one.");
		counter.finished();
	}
	catch (ClientException ce) {
	    if (ce.msg == null) {
			System.err.println("Network timed out waiting for a reply from the server.");
		}
	    else if (ce.msg instanceof RequestFailed) {
			System.err.println("The key you requested could not be found anywhere in the network.");
	    }
	    else if (ce.msg instanceof TimedOut) {
			System.err.println("The key you requested could not be found within HTL hops.");
	    }
	    else {
			System.err.println("Received unexpected reply: " + ce.msg);
		}
		counter.finished();
	}

}

public void setListeningAddress(String listeningAddress)
{
	this.listeningAddress = listeningAddress;
}

public void setHopsToLive(long htl)
{
	this.htl = htl;
}

public void callback(){
	try{
		if (out!=null)
			out.close();
	}catch(Exception e){
		e.printStackTrace();
	}
}

}

