package Freenet.message;
import Freenet.*;
import Freenet.node.*;
import Freenet.support.*;

public class QueryRestarted extends Message
{

    public static final String messageName = "QueryRestarted";

    public QueryRestarted(RawMessage m) throws InvalidMessageException
    {
	super(m);
    }

    public QueryRestarted(long idnum, long htl)
    {
	super(idnum, htl, (long)0);
    }

    
    public RawMessage toRawMessage()
    {
	RawMessage raw=super.toRawMessage();
	raw.messageType="QueryRestarted";
	raw.trailingFieldName="EndMessage";
	return raw;
    }


    public MessageMemory pReceived(Node n, MessageMemory sb)
    {
	if (sb==null) { // already lost mm
	    return null;
	} else {
	    if( sb instanceof KeyedMM ) {
	      KeyedMM kmm = (KeyedMM) sb;
	      if (!kmm.lastAddr.equals(source)) {
		// Stale QueryRestarted from a node we gave up on
		Logger.log("message/QueryRestarted.java","Stale QueryRestarted from " + source + ", expected from " + kmm.lastAddr,Logger.DEBUG);
		return sb;
	      }
	    }
	    Callback cb = Node.timer.cancel(id);
	    try {
		sb.replyCon = sendBack(n, sb);
		if (!(cb instanceof RequestCB)) return sb; //WTF have you been shoving up my timer?!? :-)
		RequestCB rcb = (RequestCB) cb;
		Node.timer.add(id, rcb.hopsToLive * Node.timePerHop, rcb);
	    } catch (SendFailedException sfe) {
		Logger.log("message/QueryRestarted.java","Send failed on return to " + sfe.peer,Logger.NORMAL);
	    }
	    return sb;
	}
    }

    protected MessageMemory timeOut(Node n, MessageMemory sb)
    {
	Logger.log("message/QueryRestarted.java","Errant QueryRestarted message died",Logger.NORMAL);
	return null;
    }
}  
