package Freenet;

import java.io.*;
import java.net.*;

public class tcpConnection extends Connection
{
  protected Socket sock=null;

  private class ConnectThread extends Thread
  { 
    private tcpAddress tcpaddr;
      private Thread parent;
    public ConnectThread(tcpAddress addr,Thread parent)
    {
      super();
      tcpaddr=addr;
      this.parent=parent;
    }

    public void run()
    { 
      try { sock=new Socket(tcpaddr.host, tcpaddr.port); }
      catch(IOException e) { sock = null; }
      if (parent!=null) parent.interrupt();
    }
      public void timedout() {
	  parent = null;
      }

  }

  public String toString()
  {
    return getPeerAddress().toString();
  }

  public tcpConnection(tcpAddress addr) throws UnknownHostException,
      IOException, ConnectTimedOutException
  {
      ConnectThread st = new ConnectThread(addr,Thread.currentThread()); 
      st.start();
      try {
	  Thread.sleep(Core.connectTimeout); 
      } catch(InterruptedException e) {
	  //interrupted is a good thing here
      }
      if(sock==null) {
	  st.timedout();
	  throw new ConnectTimedOutException();
      }
      in=sock.getInputStream();
      out=sock.getOutputStream();
  }

  public tcpConnection(Socket sock) throws IOException
    {
      this.sock = sock;
      in=sock.getInputStream();
      out=sock.getOutputStream();
    }

  public void close()
  {
    try { 
      in.close();
      in=null;
      out.close();
      out=null;
      sock.close(); 
    }
    catch(Exception e) 
      {
	// It may have been closed remotely in which case
	// sock.close will throw an exception.  We really don't
	// care though.
      }
  }

    public void setSoTimeout(int timeout) throws IOException {
	if (sock != null)
	    sock.setSoTimeout(timeout);
	else
	    throw new IOException();
    }
    
    public Address getMyAddress(ListeningAddress lstaddr)
    {
	return (sock == null)? null : 
	    new Address("tcp",
			new tcpAddress(sock.getLocalAddress(),
				       ((tcpListeningAddress)lstaddr.address).port));
    }

    public Address getMyAddress()
    {
	return (sock == null)? null :
	    new Address("tcp",
			new tcpAddress(sock.getLocalAddress(),
				       (short)sock.getLocalPort()));
    }
    public Address getPeerAddress(ListeningAddress lstaddr)
    {
	return (sock == null)? null :
	    new Address("tcp",
			new tcpAddress(sock.getInetAddress(),
				       ((tcpListeningAddress)lstaddr.address).port));
    }
    public Address getPeerAddress()
    {
	return (sock == null)? null : 
	    new Address("tcp",
			new tcpAddress(sock.getInetAddress(),
				       (short)sock.getPort()));
    }
}
