@ECHO OFF
rem Script by bil@linuxstart.com
rem Edited by twh1@doc.ic.ac.uk, dave@c2labs.com

echo Freenet installation
echo.
echo You are about to install a beta quality release of Freenet
echo This means that we *know* there are many bugs in it but we
echo need you to test it to let us know what they are.  Freenet is
echo being updated daily so it is recommended that you regularly 
echo download and install a new snapshot.  You should not be 
echo surprised if Freenet doesn't compile, or doesn't run - but
echo if this happens please email freenet-dev@lists.sourceforge.net
echo to let the development team know that there is a problem.
echo.
echo WARNING: This release of Freenet is a proof-of-concept to test
echo scalability and routing.  It does not (yet) provide any 
echo meaningful security!  Please do not insert or request any 
echo material which would place you at risk if your anonymity were 
echo compromised.  If you require strong anonymity, please wait
echo for the next release.  However, if you want to help us test 
echo and develop the system, please carry on!
echo.
echo You should already have run build.bat to compile Freenet.
echo If you have not done this yet, please press Ctrl/C now and
echo run build.bat first.
echo.

pause

if not "%1" == "" set FREENET_INSTALL_DIR=%1
if "%FREENET_INSTALL_DIR%" == "" set FREENET_INSTALL_DIR=C:\Freenet

echo.
echo Freenet will be installed in %FREENET_INSTALL_DIR%
echo.
echo To install in a different location, pass that location
echo as an argument, e.g., "install D:\MyFolder\Freenet".
echo.

pause

	  echo Installing Freenet in %FREENET_INSTALL_DIR%
	  mkdir "%FREENET_INSTALL_DIR%"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet\message"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet\support"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet\crypt"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet\node"
	  mkdir "%FREENET_INSTALL_DIR%\Freenet\client"

	  copy freenet.ini "%FREENET_INSTALL_DIR%\freenet.ini"
	  cd ..
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\*.class"
	  cd message
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\message\*.class"
	  cd ..\support
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\support\*.class"
	  cd ..\crypt
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\crypt\*.class"
	  cd ..\node
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\node\*.class"
	  cd ..\client
	  copy *.class "%FREENET_INSTALL_DIR%\Freenet\client\*.class"

	  echo Copying batch files for freenet

	  cd ..\scripts
	  copy fserve.in "%FREENET_INSTALL_DIR%\fserve.bat"
	  copy finsert.in "%FREENET_INSTALL_DIR%\finsert.bat"
	  copy frequest.in "%FREENET_INSTALL_DIR%\frequest.bat"

echo Installation done.  cd to %FREENET_INSTALL_DIR% and type 'fserve [options]' to start
echo the server, or 'fserve -help' for usage information.  Check freenet.log in
echo %FREENET_INSTALL_DIR% for any error messages once the server is running.
echo.
echo Type 'finsert' or 'frequest' to get usage information for the client.

set FREENET_INSTALL_DIR=

:_end

